<div class="page-header">
  <h3 class="page-title">
    <span class="page-title-icon bg-gradient-primary text-white mr-2">
      <i class="mdi mdi-cake"></i>
    </span>
    Formatos
  </h3>
  <nav aria-label="breadcrumb">
    <ol class="breadcrumb">
      <li class="breadcrumb-item"><a routerLink="/dashboard">Inicio</a></li>
      <li class="breadcrumb-item"><a routerLink="/tipe-product">Productos</a></li>
      <li class="breadcrumb-item active" aria-current="page">Formatos</li>
    </ol>
  </nav>
</div>
<!-- boton  -->
<div class="row d-flex justify-content-between align-items-baseline" style="margin-right:auto; margin-left:auto;">
  <div></div>
  <button type="button" class="btn btn-dark btn-fw" (click)="openModalCrear(MC)">
    <i class="mdi mdi-plus-box">Crear formato</i>
  </button>
</div>
<!-- boton -->
<!-- Inicio de table -->
<div class="row">
  <div class="col-md-12 grid-margin stretch-card">
    <div class="card">
      <div class="card-body">
        <div class="d-sm-flex align-items-center mb-4">
          <h4 class="card-title mb-sm-0">{{param.nombre}}</h4>
        </div>
        <div class="table-responsive border rounded p-1">
          <table datatable [dtOptions]="dtOptions" [dtTrigger]="dtTrigger" class="table table-striped">
            <thead>
              <tr>
                <th class="font-weight-bold">Nombre</th>
                <th class="font-weight-bold">Valor</th>
                <th class="font-weight-bold">Descuento</th>
                <th class="font-weight-bold">Valor valorización</th>
                <th class="font-weight-bold">Fecha valorización</th>
                <th class="font-weight-bold">Acciones</th>
              </tr>
            </thead>
            <tbody>
              <tr *ngFor="let item of formatos">
                <td>{{ item.nombre }}</td>
                <td>${{ item.valor }}</td>
                <td>${{ item.descuento }}</td>
                <td>${{ item.valor_valorizacion }}</td>
                <td>{{ item.fecha_valorizacion | date:'dd-MM-yyy'}}</td>
                <td>
                  <button type="button" class="btn btn-danger btn-icon" (click)="eliminarFormato(item.id)" placement="bottom" ngbTooltip="Eliminar formato">
                    <i class="mdi mdi-delete-forever"></i>
                  </button>
                  <button type="button" class="btn btn-inverse-dark btn-icon" (click)="openModal(EditModal); setFormato(item)" placement="bottom" ngbTooltip="Editar formato">
                    <i class="mdi mdi-grease-pencil"></i>
                  </button>
                  <button type="button" class="btn btn-warning btn-icon" (click)="verIngredientes(item); openModal(modalIngrediente)" placement="bottom" ngbTooltip="Ver detalle" >
                    <i class="mdi mdi-eye"></i>
                  </button>
                </td>
              </tr>
            </tbody>
          </table>
        </div>
      </div>
    </div>
  </div>
</div>
<!-- Fin de table -->

<!-- Modal crear inicio -->
<ng-template class="modal fade" #MC let-modal>
  <div class="modal-content">
    <div class="modal-header">
      <button type="button" class="close" data-bs-dismiss="modal" aria-label="Close" (click)="modal.dismiss()">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
    <div class="modal-body">
      <div class="col-12 stretch-card">
        <div class="card-body" [formGroup]="productCreate">
          <h4 class="card-title">Crear formato</h4>
          <div class="forms-sample">
            <div class="form-group">
              <label for="exampleInputName2">Nombre de formato</label>
              <input type="text" class="form-control" id="exampleInputName2" placeholder="Ingrese un nombre" #nombre
                style="background-color:dark" formControlName="nombre">
            </div>
          </div>
          <div class="forms-sample">
            <div class="form-group">
              <label for="exampleInputName2">Valor</label>
              <input type="number" class="form-control" id="exampleInputName2" placeholder="$"
                #valor style="background-color:dark" formControlName="valor">
            </div>
          </div>
          <!-- inicio agregar ingrediente -->
          <div class="card">
            <div class="card-body">
              <ng-container formArrayName="ingredientes">
                <div class="table-responsive pt-3">
                  <table class="table table-bordered">
                    <thead>
                      <tr>
                        <th>Ingrediente</th>
                        <th>Cantidad utilizada</th>
                        <th>
                          <i class="mdi mdi-plus-box plus" (click)="addIngrediente()" placement="bottom"
                          ngbTooltip="Agregar producto"></i>
                        </th>
                      </tr>
                    </thead>
                    <tbody>
                      <ng-container *ngFor=" let ingredientesFormGroup of ingredientes.controls; let i = index">
                        <tr [formGroupName]="i">
                          <td>
                            <div class="form-group">
                              <div class="input-group">
                                <div class="input-group-prepend">
                                </div>
                                <select class="custom-select" id="id" formControlName="id">
                                  <option [ngValue]="null" selected>Seleccione</option>
                                  <option *ngFor="let item of tipoIngrediente" [value]="item.id">{{item.nombre}} {{ item.marca.nombre}}</option>
                                </select>
                              </div>
                            </div>
                          </td>
                          <td>
                            <div class="forms-sample">
                              <div class="form-group">
                                <input type="number" class="form-control" id="exampleInputName2" placeholder="Ingrese una cantidad" #cantidad
                                  style="background-color:dark" formControlName="cantidad">
                              </div>
                            </div>
                          </td>
                          <td>
                            <i class="remove mdi mdi-close remove" (click)="removeIngrediente(i)" placement="bottom"
                            ngbTooltip="Eliminar producto"></i>
                          </td>
                        </tr>
                      </ng-container>
                    </tbody>
                  </table>
                  <br>
                </div>
              </ng-container>
            </div>
          </div>
          <!-- final agregar ingrediente -->
        </div>
      </div>
    </div>
    <div class="modal-footer">
      <button type="submit" class="btn btn-primary mr-2"
        (click)="crearProducto(productCreate.value, modal)" [disabled]="this.productCreate.invalid">Crear</button>
      <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="modal.dismiss()">Cancelar</button>
    </div>
  </div>
</ng-template>

<!-- Modal crear rol final -->

<!-- ---------------------------------------------------------------------------------------------------------------------------------------------------- -->

<!-- Modal editar inicio -->
<ng-template class="modal fade" #EditModal let-modal>
  <div class="modal-content">
    <div class="modal-header">
      <button type="button" class="close" data-bs-dismiss="modal" aria-label="Close" (click)="modal.dismiss()">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
    <div class="modal-body">
      <div class="col-12 stretch-card">
        <div class="card-body" [formGroup]="productEdit">
          <h4 class="card-title">Editar formato</h4>
          <div class="forms-sample">
            <div class="form-group">
              <label for="exampleInputName2">Nombre de formato</label>
              <input type="text" class="form-control" id="exampleInputName2" placeholder="Ingrese un nombre" #nombre
                style="background-color:dark" formControlName="nombre">
            </div>
          </div>
          <div class="forms-sample">
            <div class="form-group">
              <label for="exampleInputName2">Valor</label>
              <input type="number" class="form-control" id="exampleInputName2" placeholder="$"
                #valor style="background-color:dark" formControlName="valor">
            </div>
          </div>
          <div class="forms-sample">
            <div class="form-group">
              <label for="exampleInputName2">Descuento</label>
              <input type="number" class="form-control" id="exampleInputName2" placeholder="Ingrese un descuento" #descuento
                style="background-color:dark" formControlName="descuento">
            </div>
          </div>
          <!-- inicio agregar ingrediente -->
          <div class="card">
            <div class="card-body">
              <ng-container formArrayName="ingredientes">
                <div class="table-responsive pt-3">
                  <table class="table table-bordered">
                    <thead>
                      <tr>
                        <th>Ingrediente</th>
                        <th>Cantidad utilizada</th>
                        <th>
                          <i class="mdi mdi-plus-box plus" (click)="addIngrediente()" placement="bottom"
                          ngbTooltip="Agregar producto"></i>
                        </th>
                      </tr>
                    </thead>
                    <tbody>
                      <ng-container *ngFor=" let ingredientesFormGroup of ingredientes.controls; let i = index">
                        <tr [formGroupName]='i'>
                          <td>
                            <div class="form-group">
                              <div class="input-group">
                                <div class="input-group-prepend">
                                </div>
                                <select class="custom-select" id="id" formControlName="id" name="id" >
                                  <option [ngValue]="null" selected>Seleccione</option>
                                  <option *ngFor="let item of tipoIngrediente" [value]='item.id'>{{ item.nombre }} {{ item.marca.nombre}}</option>
                                </select>
                              </div>
                            </div>
                          </td>
                          <td>
                            <div class="forms-sample">
                              <div class="form-group">
                                <input type="number" class="form-control" id="exampleInputName2" placeholder="Ingrese una cantidad" #cantidad
                                  style="background-color:dark" formControlName="cantidad">
                              </div>
                            </div>
                          </td>
                          <td>
                            <i class="remove mdi mdi-close remove" (click)="removeIngredienteEdit(i)" placement="bottom"
                            ngbTooltip="Eliminar producto"></i>
                          </td>
                        </tr>
                      </ng-container>
                    </tbody>
                  </table>
                  <br>
                </div>
              </ng-container>
            </div>
          </div>
          <!-- final agregar ingrediente -->
        </div>
      </div>
    </div>
    <div class="modal-footer">
      <button type="submit" class="btn btn-primary mr-2"
        (click)="guardarEdit(productEdit.value, modal)" [disabled]="this.productEdit.invalid">Guardar</button>
      <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="modal.dismiss()">Cancelar</button>
    </div>
  </div>
</ng-template>

<!-- Modal crear rol final -->

<!-- --------------------------------------------------------------------------------------------------------------------------------------------- -->

<!-- Modal ver detalle inicio -->
<ng-template class="modal fade" #modalIngrediente let-modal>
  <div class="modal-content">
    <div class="modal-header">
      <button type="button" class="close" data-bs-dismiss="modal" aria-label="Close" (click)="modal.dismiss()">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
    <div class="modal-body">
      <div class="row">
        <div class="col-md-12 grid-margin stretch-card">
          <div class="card">
            <div class="card-body">
              <div class="d-sm-flex align-items-center mb-4">
                <h4 class="card-title mb-sm-0"> {{infoFormato.producto.nombre}} {{infoFormato.nombre}} </h4>
              </div>
              <div class="table-responsive border rounded p-1">
                <table class="table table-striped">
                  <thead>
                    <tr>
                      <th class="font-weight-bold">Ingrediente</th>
                      <th class="font-weight-bold">Cantidad</th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr *ngFor="let item of ingredientesFormato">
                      <td>{{ item.nombre }} {{ item.marca.nombre }}</td>
                      <td>{{ item.formato_has_ingrediente.cantidad }} {{ item.unidad_medida }} </td>
                    </tr>
                  </tbody>
                </table>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="modal-footer">
      <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="modal.dismiss()">Cerrar</button>
    </div>
  </div>
</ng-template>

<!-- Modal crear rol final -->